#include <QCoreApplication>
#include <QDebug>
#include <QContextMenuEvent>
#include "mainwindow.h"
#include "ui_mainwindow.h"

class MyMenu : public QMenu {
public:
  MyMenu(QWidget* parent = nullptr) : QMenu(parent) {}
protected:
  void closeEvent(QCloseEvent* event) override;
  bool event(QEvent* e) override;
};

void MyMenu::closeEvent(QCloseEvent * event)
{
  qDebug() << "Close event called for MyMenu";
  QMenu::closeEvent(event);
}

bool MyMenu::event(QEvent* e)
{
  qDebug() << "Event:" << e->type();
  return QMenu::event(e);
}


MainWindow::MainWindow(QWidget *parent) :
  QMainWindow(parent),
  ui(new Ui::MainWindow)
{
  ui->setupUi(this);
}

MainWindow::~MainWindow()
{
  delete ui;
}

void MainWindow::contextMenuEvent(QContextMenuEvent* e)
{
  QApplication::processEvents();
  QApplication::flush();
  QMenu* menu = new MyMenu(nullptr);
  menu->addAction("Test");
  qDebug() << "Creating menu";
  QApplication::processEvents();
  menu->exec(e->globalPos());
  qDebug() << "Menu executed";
}
